function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import Color from "./../AppearanceEdit/Color";
import IconPanel from "./../AppearanceEdit/IconPanel";
import { Input } from '@pisell/materials';
import { Divider } from 'antd';
import React, { forwardRef, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "./index.less";
var AppearanceEdit = function AppearanceEdit(props, ref) {
  var colorTitle = props.colorTitle,
    _props$isShowName = props.isShowName,
    isShowName = _props$isShowName === void 0 ? true : _props$isShowName,
    propsName = props.name,
    propsColor = props.color,
    propsIcon = props.icon,
    style = props.style;
  var inputRef = useRef(null);
  var _useState = useState('Untitled Base'),
    _useState2 = _slicedToArray(_useState, 2),
    name = _useState2[0],
    setName = _useState2[1];
  var _useState3 = useState('#7F56D9'),
    _useState4 = _slicedToArray(_useState3, 2),
    color = _useState4[0],
    setColor = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    icon = _useState6[0],
    setIcon = _useState6[1];
  useEffect(function () {
    propsName && setName(propsName);
    propsColor && setColor(propsColor);
    propsIcon && setIcon(propsIcon);
  }, [propsName, propsColor, propsIcon]);
  useEffect(function () {
    var _inputRef$current;
    inputRef === null || inputRef === void 0 || (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 || _inputRef$current.focus({
      cursor: 'all'
    });
  }, []);
  useImperativeHandle(ref, function () {
    return {
      getDetail: function getDetail() {
        return {
          name: name,
          color: color,
          icon: icon
        };
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "appearance-edit-wrap",
    style: style
  }, isShowName && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Input, {
    value: name,
    onChange: function onChange(e) {
      return setName(e.target.value);
    },
    ref: inputRef
  }), /*#__PURE__*/React.createElement(Divider, null)), /*#__PURE__*/React.createElement("div", null, colorTitle && /*#__PURE__*/React.createElement("div", {
    className: "color-title"
  }, colorTitle), /*#__PURE__*/React.createElement(Color, {
    value: color,
    onChange: setColor
  })), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(IconPanel, {
    value: icon,
    onChange: setIcon,
    color: color,
    name: name
  })));
};
export default /*#__PURE__*/forwardRef(AppearanceEdit);